package dk.topsecurity;

import java.io.*;
import java.util.*;
import javax.security.auth.login.*;
import javax.security.auth.*;
import javax.security.auth.callback.*;

/**
 * <p> Application demonstrates use of the JAAS API, by attempting to 
 * authenticate a user. Results of the authentication attempt are printed to 
 * the commandline.</p>
 */
public class TopsecurityClientAuthentication {

/**
 * Interacts with user via commandline and attempts to
 * authenticate the user.<p>
 * 
 * @param args Commandline input arguments (there are none).
 */
  public static void main(String[] args) {

	LoginContext logctx = null;
		
//1ST PART - ONLY ASSOCIATED WITH AUTHENTICATION
	try {
/* Constructor for LoginContext is intialized with a string containing
 * classname for the LoginModule implementation as specified in the JAAS 
 * login configuration file. Second parameter is an object of type 
 * CallbackHandler, which will actually handle the authentication attempts.
 */
    		logctx = new LoginContext( "TopsecurityJAASModule", new TopsecurityCallbackHandler());
	} catch( LoginException le ) {
		System.err.println("\t[TopsecurityClient] LoginContext creation failed. "+ le.getMessage());
    		System.exit( -1 );
	} catch( SecurityException se ) {
		System.err.println("\t[TopsecurityClient] LoginContext creation failed. "+ se.getMessage());
    		System.exit(-1);
	}//end try/catch 

	try {
		logctx.login(); // Attempt to authenticate user
			// Authentication succeeded if no exception is thrown
		System.out.println("\t[TopsecurityClient] Authentication succeeded.");
	} catch( LoginException le ) {
		System.err.println("\t[TopsecurityClient] Authentication failed. " + le.getMessage());
		System.exit( -1 );
	}//end try/catch

    }//end main()
}//end main class 